function [modes] = ReconsMod(Wbb,as1,na,nv,j0,Fb,Fc,gamma,cas,cas2)
%% function sqt1 : computes the synchrosqueezing transform of signal s

%On considere la transformation avec l'ondelette bump

%cas = 1, ondelette de Morlet, cas = 2, ondelette Bump, cas = 3, window
%wavelet
%cas2 = 2 reconstruction using thresholding threshholding on the wavelet, cas = 1 reconstruction using the 
%wavelet support  

[Las,N] = size(Wbb);
lgam = length(gamma);
nbmode = zeros(lgam,N);
 
%we identify the number of modes as a function of gamma

for p=1:lgam,
 for k=1:N,
  nbmode(p,k) = 0; 
  for j = 1:Las-1,
   if ((abs(Wbb(j+1,k)) > gamma(p)) && (abs(Wbb(j,k)) < gamma(p)))
      nbmode(p,k) = nbmode(p,k)+1;
   end
  end
 end
end

%we consider the best most probable number of mode 

nbmoy = round(mean(round(mean(nbmode,2))));
nbmoy

%we look for the best value for gamma which gives a number of modes at larger 
%or equal to the the expected one for each t 

vectopt = nbmoy*ones(1,N);

kopt  = 0;
kopt1 = 0;

for k=1:lgam
   if k == 1,
      if (sum(nbmode(k,:)-vectopt) == sum(abs(nbmode(k,:)-vectopt)))
        valopt = mean(nbmode(k,:)-vectopt);
        kopt = k;
       else
        valopt = 10000;
       end 
   else 
      if (sum(nbmode(k,:)-vectopt) == sum(abs(nbmode(k,:)-vectopt)))
       valcour = mean(nbmode(k,:)-vectopt);
       if (valcour < valopt)
        valopt = valcour;
        kopt = k;
       end
      end 
   end
end

if (kopt == 0) %meaning that we have not found the proper gamma
%in that case we look for the optimal gamma by considering the value that
%gives on average the best results

 for k=1:lgam
   if k == 1,
      valopt = mean(abs(nbmode(k,:)-vectopt)); 
      kopt1 = k;
   else 
      valcour = mean(abs(nbmode(k,:)-vectopt));
      if (valcour < valopt)
       valopt = valcour;
       kopt1 = k;
      end
   end 
 end
end


%we reconstruct the modes using the value for gamma given by kopt
%we start from the high frequency component and we reconstruct the signal components by components     

Tx = zeros(nbmoy,N); 

%we start from a time where we have detected the true number of modes

found = 0;
t0=1;
if (kopt ~= 0)
 while (found == 0)
  if (nbmode(kopt,t0) ~= nbmoy) 
    t0 = t0+1;
  else
    found = 1;
  end   
 end
else
 while (found == 0)
  if (nbmode(kopt1,t0) ~= nbmoy) 
    t0 = t0+1;
  else
    found = 1;
  end   
 end
end  

if (kopt ~= 0)
  Gkopt = gamma(kopt);
  [Tx,Wbb] = findmode1(Wbb,as1,Fb,Fc,j0,t0,Gkopt,nbmode(kopt,:),nbmoy,nv,na,cas2);
end
if (kopt1 ~= 0)
  Gkopt = gamma(kopt1);
  [Tx,Wbb] =  findmode1(Wbb,as1,Fb,Fc,j0,t0,Gkopt,nbmode(kopt1,:),nbmoy,nv,na,cas2);
end    


%modes = zeros(nbmoy,length(t));
if cas == 2,
 CPsi = quadgk(@(x)PsiHat(x,Fc,Fb),Fc-Fb,Fc+Fb);
elseif cas == 3,
 CPsi = quadgk(@(x)PsiConst(x),Fc-Fb,Fc+Fb);   
else    
 CPsi = quadgk(@(x)PsiMor(x,Fc,Fb),0,inf);  
end
modes = Tx/CPsi;



